"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.options = options;

var _fs = require("fs");

var _path = require("path");

var _defaults = require("./defaults");

// @ts-check

/**
 * @type {IOptions | null}
 */
let opts = null;
/**
 * @param {string|undefined} cwd
 * @returns {IOptions}
 */

function options(cwd = process.cwd()) {
  if (opts) {
    return opts;
  }

  const path = (0, _path.resolve)(cwd, _defaults.defaults.optionsFileName);
  const exists = (0, _fs.existsSync)(path);

  if (exists) {
    opts = require(path);
  } else {
    opts = {};
  }

  return opts || {};
}
//# sourceMappingURL=options.js.map